/* PTS */


package rCr._BUILDER;


import rCr.agentModel.I_AgentModel;
import rCr.initiator.I_Config;


/**
 *  @author PTS
 *  @since MAY.2004
 */
abstract public class C_BUILDER_Center
extends C_BUILDER_RcR
{
   abstract protected int getNumberOfTeams();


   protected void setAgentModelCommunicationRestriction( I_AgentModel acl_agentModel )
   {
      // 2004 competition rule: 2 * #{teams controled by this center type}
      int lint_hearingLimit = 2 * getNumberOfTeams();
      acl_agentModel.setHearingLimit( lint_hearingLimit );
   }
}
