/* PTS */


package rCr._BUILDER;


import rCr.initiator.I_InitiatorCommunicator;
import rCr.util.X_PreCondicao;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public class C_BUILDER_Director
{
   /**
    * @directed 
    */
   private I_BUILDER concreteBuilder;


   public C_BUILDER_Director( I_BUILDER aitf_concreteBuilder )
   {
      this.concreteBuilder = aitf_concreteBuilder;
   }


   public void construct( I_InitiatorCommunicator aitf_initiatorCommunicator )
   {
      try
      {
         // Connections
         concreteBuilder.buildConnector( aitf_initiatorCommunicator );
         concreteBuilder.buildAgentToPlatformConnection();

         // Agent Components
         concreteBuilder.buildAgentModel();
         concreteBuilder.buildAgentWorkingMemory();
         concreteBuilder.buildAgentPrimaryCapability();
         concreteBuilder.buildAgent();

         // Link Agent Components
         concreteBuilder.buildAgentToComponentLinkage();
      }
      catch( X_PreCondicao lexc_preCondicao )
      {
         throw new Error( lexc_preCondicao.obterMensagem() + " " + "(execucao do C_BUILDER_Director::construct)" );
      }
   }
}
