/* PTS */


package rCr._BUILDER;

import rCr.initiator.I_InitiatorCommunicator;
import rCr.util.X_PreCondicao;

/**
 *  @author PTS
 *  @since MAY.2004
 */
public interface I_BUILDER 
{
   /** @link dependency */
   /*#rCr.initiator.I_InitiatorCommunicator lnkI_InitiatorCommunicator;*/

   public void buildConnector( I_InitiatorCommunicator aitf_iniciadorComunicador ) throws X_PreCondicao;
   public void buildAgentToPlatformConnection() throws X_PreCondicao;
   public void buildAgentModel() throws X_PreCondicao;
   public void buildAgentWorkingMemory() throws X_PreCondicao;
   public void buildAgentPrimaryCapability() throws X_PreCondicao;
   public void buildAgent();
   public void buildAgentToComponentLinkage() throws X_PreCondicao;
   public Runnable getResult();
}
