/* PTS */

package rCr.agent.rCrAgentBaseline;


import rCr.agent.skillLevel_0.I_PrimaryInteraction;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import yab.agent.object.AmbulanceCenter;
import yab.agent.object.RealObject;
import yab.agent.object.Humanoid;
import yab.agent.object.MotionlessObject;
import java.lang.reflect.Array;
//import java.lang.reflect.Array;


/**
 *  @author PTS
 *  @since SET.2001
 *  @author AR
 *  @since FEB.2004
 */
public class C_AmbulanceCenter
extends C_Center
{
   // Agent Primary Capabilities
   // --------------------------
   private I_PrimaryInteraction primaryCapability;


   public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   {
      this.primaryCapability = ( I_PrimaryInteraction )acl_primaryCapability;
   }


   protected AmbulanceCenter self()
   {
      return ( AmbulanceCenter )currentDisasterSpace.self;
   }


   public void preAct()
   {
   }


   public void act()
   {
   }


   public void postAct()
   {
   }


   protected void handleCommunicativeAct( RealObject  aobj_emissor, String astr_actoDiscurso )
   {
      String[] ad_array = astr_actoDiscurso.split(" ");
	   int length = Array.getLength( ad_array );
      // recebe do centro dos bombeiros e envia para as ambulancias
	   if( ( aobj_emissor instanceof MotionlessObject ) &&
          length == 6 &&
          ad_array[1].equals("AT") &&
          ad_array[0].equals("FB") &&
          ad_array[2].equals("BURIED")  )
      {
	      //println("AmbulanceCenter, AD: "+ astr_actoDiscurso);
	      primaryCapability.tell( astr_actoDiscurso );
	   }

      // recebe das ambulancias e envia para centro de policias
	   if( ( aobj_emissor instanceof Humanoid ) &&
          ( length == 6 || length == 5 ) &&
          ad_array[1].equals("PF") &&
          ad_array[0].equals("AT") &&
          ( ad_array[2].equals("BLOCKED") || ad_array[2].equals("ROAD_BLOCKADE") )  )
      {
	      //println("AmbulanceCenter, AD: "+ astr_actoDiscurso);
	      primaryCapability.tell( astr_actoDiscurso );
	   }
	}


	private void println( String str)
   {
	   System.out.println(str);
	}
}
