/* PTS */


package rCr.agent.rCrAgentBaseline;


import rCr.initiator.I_Config;
import rCr.util.U_Depurador;
import rCr.util.I_Depurador;
import rCr.util.U_Geral;
import yab.agent.object.AmbulanceCenter;
import yab.agent.object.FireStation;
import rCr.agent.skillLevel_0.I_PrimaryInteraction;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import yab.agent.object.RealObject;
import java.lang.reflect.Array;
import yab.agent.object.Humanoid;
import yab.agent.object.MotionlessObject;


/**
 *  @author PTS
 *  @since SET.2001
 *  @author AR
 *  @since FEB.2004
 */
public class C_FireStation
extends C_Center
{
   // Agent Primary Capabilities
   // --------------------------
   
   private I_PrimaryInteraction primaryCapability;


   public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   {
      this.primaryCapability = ( I_PrimaryInteraction )acl_primaryCapability;
   }


   protected FireStation self()
   {
      return ( FireStation )currentDisasterSpace.self;
   }


   public void preAct()
   {
   }


   public void act()
   {
   }


   public void postAct()
   {
   }


   protected void handleCommunicativeAct( RealObject  aobj_emissor, String astr_actoDiscurso )
   {
      // PF AT BURIED BAIXO ROAD id
      // FB AT BURIED BAIXO ROAD id
      // AT AT BURIED ALTO ROAD id
	   String[] ad_array = astr_actoDiscurso.split(" ");
	   int length = Array.getLength(ad_array);
	   if( aobj_emissor instanceof Humanoid &&
          length == 6 &&
          ad_array[1].equals("AT") &&
          ad_array[0].equals("FB") &&
          ad_array[2].equals("BURIED") )
      {
         println("FireStation, AD: "+ astr_actoDiscurso);
         primaryCapability.tell( astr_actoDiscurso );
	   }

      // recebe bloqueio dos bombeiros e envia para policias
	   if( (aobj_emissor instanceof Humanoid) &&
          (length == 6 || length == 5) &&
          ad_array[1].equals("PF") &&
          ad_array[0].equals("FB") &&
          ( ad_array[2].equals("BLOCKED") || ad_array[2].equals("ROAD_BLOCKADE") ) )
      {
         println("FireStation, AD: "+ astr_actoDiscurso);
         primaryCapability.tell( astr_actoDiscurso );
	   }

      // recebe info de incendios e envia para bombeiros
      // PTS: ACHO QUE ESTE NAO E' PRECISO
      if( (aobj_emissor instanceof MotionlessObject) &&
           (length == 6 || length == 5) &&
           ad_array[1].equals("FB") &&
           ( ad_array[0].equals("AT") || ad_array[0].equals("PF") )  &&
           ( ad_array[2].equals("BUILDING_BURNING") || ad_array[2].equals("BURNING") ) )
      {
         println("FireStation, AD: "+ astr_actoDiscurso);
         primaryCapability.tell( astr_actoDiscurso );
      }
   }


   private void println( String str)
   {
	   System.out.println(str);
	}
}
