/* PTS */


package rCr.agent.rCrAgentRRR;


import rCr.agent.rCrAgentRRR.C_Center;
import rCr.agent.skillLevel_0.I_PrimaryInteraction;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import yab.agent.object.AmbulanceCenter;
import yab.agent.object.RealObject;
import rCr.agent.rCrAgentRRR.r0.E_RuleSet;
import rCr.agent.rCrAgentRRR.r0.C_RuleEngine;
import rCr.agentWorkingMemory.E_SpaceGrid;


/**
 *  @author PTS
 *  @since SET.2001
 *  @author AR
 *  @since FEB.2004
 */
public class C_AmbulanceCenter
extends C_Center
{
   // Agent Primary Capabilities
   // --------------------------
   private I_PrimaryInteraction primaryCapability;
   // (BEGIN) Rule Specification and Rule Engine
   E_RuleSet r0_ruleSet = null;
   C_RuleEngine r0_ruleEngine = new C_RuleEngine();
   // (END) Rule Specification

   // =======================================================
   // Each OTHER Institution MapGrid Coordination Perspective
   private E_SpaceGrid spaceGrid_POLICE = null;
   private E_SpaceGrid spaceGrid_FIRE = null;
   // =======================================================

   // ============================================
   // (BEGIN) type cast abstract redefined methods
   // ============================================
   public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   { this.primaryCapability = ( I_PrimaryInteraction )acl_primaryCapability; }

   protected AmbulanceCenter self()
   { return ( AmbulanceCenter )currentDisasterSpace.self; }
   // ==========================================
   // (END) type cast abstract redefined methods
   // ==========================================


   public void preSimulation()
   {
      // ===================================
      // Always assert super "preSimulation"
      super.preSimulation();
      // ===================================

      // ----------------
      // Build R0 RuleSet
      // ----------------
      // r0_ruleSet = new E_RuleSet_PF( this, primaryCapability, plannerCapability );

      // --------------------------------------------------------
      // Build OTHER Institution MapGrid Coordination Perspective
      // --------------------------------------------------------
      spaceGrid_POLICE = workingMemory.getSpaceGrid_POLICE();
      spaceGrid_FIRE = workingMemory.getSpaceGrid_FIRE();
   }


   public void preAct()
   {
   }


   public void act()
   {
   }


   public void postAct()
   {
   }


   protected void handleHearSay( RealObject aobj_emissor, String astr_actoDiscurso )
   {
   }


   /**
    * BLOCKADE ROAD_ID ...
    * AT ...
    */
   protected void handleHearTell( RealObject acl_sender, String astr_messageContent )
   {
      // Basic Behaviour!!!
      primaryCapability.tell( astr_messageContent );
   }


	private void println( String str)
   {
	   System.out.println(str);
	}
}
