/* PTS */


package rCr.agent.rCrAgentRRR;


import rCr.agent.skillLevel_1.problemSolver.B_GIS_RoutingProblem;
import rCr.agent.skillLevel_0.I_PrimaryCapability_Civilian;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import rCr.agent.skillLevel_0.I_PrimaryAction;
import yab.agent.object.Civilian;
import rCr.util.X_RcR_Accao;
import rCr.util.U_Depurador;
import rCr.util.I_Depurador;
import rCr.util.U_Geral;
import yab.agent.object.RealObject;
import java.util.ArrayList;
import java.util.Iterator;
import yab.agent.object.MotionlessObject;
import yab.agent.object.Road;
import rCr.agent.skillLevel_1.problemSolver.E_Node;
import java.util.HashSet;
import java.util.Collections;
import rCr.util.U_LeitorEscritorLinha;
import java.beans.Statement;
import rCr.agent.rCrAgentRRR.C_Humanoid;
import rCr.agentWorkingMemory.E_WorkingMemory_RRR;
import rCr.util.U_RcR;
import yab.agent.object.Node;


/**
 *  @author PTS
 *  @since SET.2001
 *  @since MAY.2004
 */
public class C_Civilian_RouterTest
extends C_Humanoid
{
   // Agent Primary Capabilities
   // --------------------------
   private I_PrimaryCapability_Civilian primaryCapability;

   private ArrayList myPath;
   private int iint_pathIndex = 0;
   private final int iint_delay = 1;
   private int iint_delayCounter = 0;


   // ============================================
   // (BEGIN) type cast abstract redefined methods
   // ============================================
   public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   { this.primaryCapability = ( I_PrimaryCapability_Civilian )acl_primaryCapability; }

   protected I_PrimaryAction getPrimaryAction()
   { return ( I_PrimaryAction )primaryCapability; }

   protected Civilian self()
   { return ( Civilian )currentDisasterSpace.self; }
   // ==========================================
   // (END) type cast abstract redefined methods
   // ==========================================


   public void preSimulation()
   {
      // ===================================
      // Always assert super "preSimulation"
      super.preSimulation();
      // ===================================

      println( "================================ Civilian Router Test ====================================" );

      for( Iterator xxx = currentDisasterSpace.nodes.iterator(); xxx.hasNext(); )
      {
         Node nnn = ( Node )xxx.next();
         //System.out.print( nnn.id );
         //System.out.print( " " );
         System.out.print( nnn.motionlessPosition().id );
         System.out.print( " " );
      }
      U_LeitorEscritorLinha.escrever( "FIM" );
      for( Iterator xxx = currentDisasterSpace.roads.iterator(); xxx.hasNext(); )
      {
         Road nnn = ( Road )xxx.next();
         //System.out.print( nnn.id );
         //System.out.print( " " );
         System.out.print( nnn.motionlessPosition().id );
         System.out.print( " " );
      }
      U_LeitorEscritorLinha.escrever( "FIM" );
      // workingMemory.printlnSpaceGrid();
      preSimulation_Test();
   }

   public void preSimulation_Test()
   {
      long llng_myRouterBegin, llng_myRouterEnd,
           llng_yabRouterBegin, llng_yabRouterEnd;

      System.out.println( "---" );

      System.out.println( "My: ANTES de solve" );
      llng_myRouterBegin = System.currentTimeMillis();
      // My
      // myPath = plannerCapability.getPassableRouteTo( currentDisasterSpace.buildings );
      // myPath = plannerCapability.getWiderShorterRouteTo( currentDisasterSpace.buildings );
      // myPath = plannerCapability.getShorterRouteTo( currentDisasterSpace.buildings );
      // myPath = plannerCapability.getShorterRouteTo( currentDisasterSpace.buildings, currentDisasterSpace.roads );
      // myPath = plannerCapability.getShorterRouteTo_thisRoadThroughTheOtherEndPoint();
      // myPath = plannerCapability.getShorterRouteTo_thisRoadThroughTail();
      // myPath = plannerCapability.getShorterRouteTo_roadThroughTail( ( Road )currentDisasterSpace.roads.get( 3 ) );
      // myPath = plannerCapability.getShorterRouteTo_roadThroughHead( ( Road )currentDisasterSpace.roads.get( 0 ) );
      // myPath = plannerCapability.getShorterRouteTo_roadThroughTail( ( Road )currentDisasterSpace.roads.get( 0 ) );
      // myPath = plannerCapability.getShorterRouteTo_roadThroughTail( ( Road )currentDisasterSpace.roads.get( 3 ) ); //OK
      // myPath = plannerCapability.getShorterRouteTo_roadThroughHead( ( Road )self().motionlessPosition( ) );
      //myPath = plannerCapability.getShorterRouteTo( currentDisasterSpace.buildings,
      //                                              Collections.singleton( ( ( Road )( currentDisasterSpace.roads.get( 3 ) ) ).head() ), // new HashSet(),
      //                                              Collections.singleton( ( ( Road )( currentDisasterSpace.roads.get( 0 ) ) ).head() ) );
      // myPath = plannerCapability.getShorterRouteTo( currentDisasterSpace.buildings,
      //                                              Collections.singleton( ( ( Road )( currentDisasterSpace.roads.get( 3 ) ) ).head() ),
      //                                              Collections.singleton( ( ( Road )( currentDisasterSpace.roads.get( 0 ) ) ).tail() ) );
      myPath = plannerCapability.getShorterRouteTo( ( MotionlessObject )currentDisasterSpace.roads.get( 0 ) );
      //myPath = plannerCapability.getShorterRouteTo( Collections.singleton( currentDisasterSpace.roads.get( 0 ) ),
      //                                              Collections.singleton( currentDisasterSpace.roads.get( 0 ) ) );
      //myPath = plannerCapability.getShorterRouteTo( self().motionlessPosition() );//,
      //                                              //Collections.singleton( currentDisasterSpace.roads.get( 0 ) ) );

      llng_myRouterEnd = System.currentTimeMillis();
      U_LeitorEscritorLinha.escrever( U_RcR.getIDs( myPath ) );
      System.out.println( "My: DEPOIS de solve" );

      System.out.println( "---" );

      System.out.println( "YabAI: ANTES de solve" );
      llng_yabRouterBegin = System.currentTimeMillis();
      /*
      // PTS: deprecated - better not use Yab Planner at RRR Agent Model
      // Yab
      yabPath = plannerCapabilityYab.getPassableRouteTo( currentDisasterSpace.buildings );
      llng_yabRouterEnd = System.currentTimeMillis();
      U_LeitorEscritorLinha.escrever( yabPath );
      System.out.println( "YabAI: DEPOIS de solve" );

      System.out.println( "---" );
      */

      System.out.println( "TEMPO    My: " + ( llng_myRouterEnd - llng_myRouterBegin ) );
      // System.out.println( "TEMPO YabAI: " + ( llng_yabRouterEnd - llng_yabRouterBegin ) );
   }


   public void preAct()
   {
   }


   public void act()
   throws X_RcR_Accao
   {
      //act_Test();

      // TESTES DIVERSOS AO MONITOR
      // --------------------------

      U_LeitorEscritorLinha.escrever( "MINHA MotionlessPosition Actual = " + self().motionlessPosition().id );
      // Rule
      // ----
      if( iint_delayCounter == 0 )
      {
         iint_delayCounter++;
         moveWithDefaultMonitorToDestination( getMotionlessObjectHOME () ); //R1
      }

      // Rule
      // ----
      int lint_time = currentDisasterSpace.time();
      if( lint_time < 7 )
      {
         println( "################################ MOVE BUILDING ################################" );
         myPath = plannerCapability.getShorterRouteTo( currentDisasterSpace.buildings );
         getPrimaryAction().move( myPath ); //R2
      }

      // Rule
      // ----
      if( lint_time > 10 && lint_time < 12 )
      {
         moveWithDefaultMonitorToDestination( getMotionlessObjectHOME () ); //R3
      }

      // NOT Rule (does not throw)
      // -------------------------
      if( lint_time == 12 )
      {
         println( "################################ SET NEW PLAN ################################" );
         ArrayList larr_plan = plannerCapability.getWiderShorterRouteTo( currentDisasterSpace.buildings );
         getDefaultMonitor().setON( lint_time, larr_plan );
         getDefaultMonitor().printlnAll();
      }

      // Rule
      // ----
      if( lint_time == 14 )
      {
         println( "################################ Go TO NEIGHBOUR ################################" );
         MotionlessObject lcl_neighbour = ( MotionlessObject )( self().motionlessPosition().neighborhood().iterator().next() );
         ArrayList larr_plan = plannerCapability.getWiderShorterRouteTo( lcl_neighbour );
         primaryCapability.move( larr_plan );
      }

      // Rule
      // ----
      if( lint_time == 16 )
      {
         println( "################################ REPAIR PLAN ################################" );
         getDefaultMonitor().repairPlan( lint_time );
         ArrayList larr_plan = getDefaultMonitor().getRemaningPlan( lint_time );
         getDefaultMonitor().printlnAll();
         getPrimaryAction().move( larr_plan );
      }

      // Rule
      // ----
      if( lint_time >= 18 )
      {
      println( "################################ FIM ################################" );
      ArrayList larr_plan = getDefaultMonitor().getRemaningPlan( lint_time );
      getDefaultMonitor().printlnAll();
      getPrimaryAction().move( larr_plan );
      }
      //moveHOME();
   }


   public void act_Test()
   throws X_RcR_Accao
   {
      iint_delayCounter++;
      System.out.println( iint_delayCounter );

      if( iint_pathIndex >= myPath.size() )
      {
         return;
      }

      if( iint_delayCounter >= iint_delay )
      {
         ArrayList location = new ArrayList();
         MotionlessObject newPosition = ( MotionlessObject )myPath.get( iint_pathIndex );
         location.add( newPosition );
         System.out.println( newPosition.id );

         iint_delayCounter = 0;

         // -----------------------------------------------------------------------------------------
         // Create a Statement (object with a target, methodName and arguments as per the parameters)
         // -----------------------------------------------------------------------------------------
         long llng_statementExecutionBegin, llng_statementExecutionEnd;
         llng_statementExecutionBegin = System.currentTimeMillis();
         Object[] larr_argument = { location };
         Statement lcl_statement = new Statement( primaryCapability, "move", larr_argument );
         iint_pathIndex++;
         try
         {
            lcl_statement.execute();
         }
         catch( X_RcR_Accao lcl_exception )
         {
            llng_statementExecutionEnd = System.currentTimeMillis();
            System.out.println( "TEMPO Statement execution: " + ( llng_statementExecutionEnd - llng_statementExecutionBegin ) );
            throw lcl_exception;
         }
         catch( Exception lcl_exception )
         {
            U_LeitorEscritorLinha.escrever( "XXXXXXXXXXXXXXXX" );
            U_LeitorEscritorLinha.escrever( lcl_exception );
         }

         // primaryCapability.move( location );
         // primaryCapability.move( path );
      }
   }


   public void postAct()
   {
      U_Depurador.escrever( I_Depurador.kint_depurarVerboso,
                            U_Geral.paraNomeClasse( this ),
                            "=== posActuar ===" );
   }


   protected void handleHearSay( RealObject aobj_emissor, String astr_actoDiscurso )
   {
   }


   protected void handleHearTell( RealObject aobj_emissor, String astr_actoDiscurso )
   {
   }



   private void println( String astr_message )
   {
      System.out.println( astr_message );
   }
}
