/* PTS */


package rCr.agent.rCrAgentRRR.r0;


import rCr.agent.skillLevel_0.I_PrimaryCapability_PoliceForce;
import rCr.agent.skillLevel_1.I_Planner;
import rCr.agent.rCrAgentRRR.C_Agent;


/**
 * @author PTS
 * @since JUN.2004
 * @see .xls file
 */
public class E_RuleSet_PF
extends E_RuleSet
{
   /**
    * Build AmbulanceTeam RuleSet
    * @see .xls file (rule and salience specification)
    */
   public E_RuleSet_PF( C_Agent agent, I_PrimaryCapability_PoliceForce primaryCapability, I_Planner plannerCapability )
   {
      // --------------------------
      // 1st: the Interaction Rules
      // --------------------------
      U_RuleSpecification_Interaction rsI = new U_RuleSpecification_Interaction();

      E_Rule rsI_01 =
         rsI.getRule_IF_self_ALIVE_x_BURIED_THEN_tell(
            agent, primaryCapability );

      E_Rule rsI_02 =
         rsI.getRule_IF_other_here_ALIVE_x_BURIED_THEN_tell_AT(
            agent, primaryCapability );

      E_Rule rsI_03 =
         rsI.getRule_IF_other_here_ALIVE_x_BURIED_THEN_say_AT(
            agent, primaryCapability );

      // -------------------------
      // Add the Interaction Rules
      // -------------------------
      addInteractionRule( rsI_01, 1 );
      addInteractionRule( rsI_02, 2 );
      addInteractionRule( rsI_03, 3 );

      // ---------------------
      // 2nd: the Action Rules
      // ---------------------
      U_RuleSpecification_Action rsA = new U_RuleSpecification_Action();

      E_Rule rsA_01 =
         rsA.getRule_damage_IF_self_motionlessPosition_REFUGE_THEN_rest(
            agent, primaryCapability );

      E_Rule rsA_02 =
         rsA.getRule_not_refuge_IF_self_ALIVE_DAMAGE_NOT_BURIED_THEN_moveREFUGE(
            agent, primaryCapability, plannerCapability );

      E_Rule rsA_03 =
         rsA.getRule_IF_self_ROAD_BLOCKADE_THEN_clear(
            agent, primaryCapability );

      // --------------------
      // Add the Action Rules
      // --------------------
      addActionRule( rsA_01, 1 );
      addActionRule( rsA_02, 2 );
      addActionRule( rsA_03, 3 );
   }
}
