/* PTS */


package rCr.agent.rCrAgentRRR.r0;


import rCr.agent.skillLevel_0.I_PrimaryInteraction;
import rCr.agent.rCrAgentRRR.I_Feature;
import rCr.agent.rCrAgentRRR.C_Agent;


/**
 *  @author PTS
 *  @since JUN.2004
 */
public class U_RuleSpecification_Interaction
implements I_Feature
{
   /**
    * The RuleSpecification Common "getters"
    * - getPreCondition_xxx
    * - getSituation_xxx
    * - getStatementRule_xxx
    */
   private static final U_RuleSpecification_Common rsC = new U_RuleSpecification_Common();


   public static synchronized E_Rule getRule_IF_self_ALIVE_x_BURIED_THEN_tell(
      C_Agent acl_agent, I_PrimaryInteraction acl_primaryInteraction )
   {
      E_Rule lcl_rule =
         new E_Rule( acl_agent.workingMemory,
                     rsC.getSituation_self_HEALTH_SITUATION( CND_ALIVE_x_BURIED ),
                     rsC.getStatementRule_self_HEALTH_SITUATION( acl_primaryInteraction, I_PrimaryInteraction.kstr_tell ) );
      return lcl_rule;
   }


   public static synchronized E_Rule getRule_IF_other_here_ALIVE_x_BURIED_THEN_tell_AT(
      C_Agent acl_agent, I_PrimaryInteraction acl_primaryInteraction )
   {
      E_Rule lcl_rule =
         new E_Rule( acl_agent.workingMemory,
                     rsC.getSituation_other_ALIVE_x_BURIED(),
                     rsC.getStatementRule_other_ALIVE_x_BURIED_inform_AT( acl_primaryInteraction, I_PrimaryInteraction.kstr_tell ) );
      return lcl_rule;
   }

   public static synchronized E_Rule getRule_IF_other_here_ALIVE_x_BURIED_THEN_say_AT(
      C_Agent acl_agent, I_PrimaryInteraction acl_primaryInteraction )
   {
      E_Rule lcl_rule =
         new E_Rule( acl_agent.workingMemory,
                     rsC.getSituation_other_ALIVE_x_BURIED(),
                     rsC.getStatementRule_other_ALIVE_x_BURIED_inform_AT( acl_primaryInteraction, I_PrimaryInteraction.kstr_say ) );
      return lcl_rule;
   }


   private static void println( String astr_message )
   {
	   System.out.println( astr_message );
	}
}
