/* PTS */


package rCr.agent.skillLevel_0;


/**
 *  @author PTS
 *  @since JUN.2004
 */
public interface I_PrimaryInteraction_Constants
{
   // A message shall consist of three parts: selfID senderID data_part.
   // The size of the data_part shall not exceed 256 bytes.
   // @see RoboCup 2004 Rescue Simulation League Rules V1.01
   public final int pint_maximum_MESSAGE_BYTES = 256;
   // To be used as message tokens:
   // - separator
   // - terminator
   // - situations (BLOCKAE, HEALTH, FIRE)
   public final String pstr_TOKEN_SEPARATOR                       = " ";
   public final String pstr_BLOCK_SEPARATOR                       = "#";
   public final String pstr_SITUATION_SEPARATOR                   = "@";
   public final String pstr_SITUATION_BLOCKADE                    = "BLOCKADE";
   public final String pstr_SITUATION_HEALTH                      = "HEALTH";
   public final String pstr_SITUATION_HEALTH_CIVILIAN_UNKNOWN     = "CIVILIAN_UNKNOWN";
   public final String pstr_SITUATION_HEALTH_RESCUE_ACCOMPLISHED  = "RESCUE_ACCOMPLISHED";
   public final String pstr_SITUATION_FIRE                        = "FIRE";
   
   // "help_me" Civilian Shout
   public final String pstr_TOKEN_HELP_ME = "help_me";
}
