/* PTS */


package rCr.agent.skillLevel_1;


import yab.agent.object.RealObject;
import yab.agent.object.MotionlessObject;
import java.util.Collections;
import java.util.Collection;
import yab.agent.B_GIS_Router_Yab_Adapter;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public class B_GIS_Router_Yab
implements I_PlannerBaseline
{
   /**
    * "Agent Self" (platform specefic)
    * (represented at DisasterSpace from YabAI)
    */
   private RealObject icl_agentSelf;


   public void setAgentSelf( RealObject acl_agentSelf )
   {
      this.icl_agentSelf = acl_agentSelf;
   }


   /**
    *****************
    * CODIGO DE YabAI
    *****************
    */
   public int[] getPassableRouteIDsTo( MotionlessObject acl_destination )
   {
      return getPassableRouteIDsTo ( Collections.singleton( acl_destination ) );
   }


   public int[] getPassableRouteIDsTo( Collection acl_destinationSet )
   {
      return B_GIS_Router_Yab_Adapter.getRoute( acl_destinationSet, icl_agentSelf ).toIDs();
   }
}
