/* PTS */


package rCr.agent.skillLevel_1;


import yab.agent.object.RealObject;
import yab.agent.object.MotionlessObject;
import java.util.Collection;
import yab.agent.object.Road;
import java.util.ArrayList;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public interface I_Planner
extends I_PlannerBaseline
{
   public void setAgentSelf( RealObject acl_agentSelf );
   ArrayList getPassableRouteTo( MotionlessObject acl_destination );
   ArrayList getPassableRouteTo( Collection acl_destinationSet );

   ArrayList getPassableRouteTo( MotionlessObject acl_destination, Collection acl_tabooLocations );
   ArrayList getPassableRouteTo( Collection acl_destinationSet, Collection acl_tabooLocations );
   ArrayList getPassableRouteTo( Collection acl_destinationSet, Collection acl_tabooLocations, Collection acl_mustGoLocations );

   ArrayList getPassableRouteFromTo( MotionlessObject acl_origin, MotionlessObject acl_destination );
   ArrayList getPassableRouteFromTo( MotionlessObject acl_origin, MotionlessObject acl_destination, Collection acl_tabooLocations );
   ArrayList getPassableRouteFromTo( MotionlessObject acl_origin, Collection acl_destinationSet, Collection acl_tabooLocations );

   ArrayList getWiderShorterRouteTo( MotionlessObject acl_destination );
   ArrayList getWiderShorterRouteTo( Collection acl_destinationSet );
   ArrayList getWiderShorterRouteTo( MotionlessObject acl_destination, Collection acl_tabooLocations );
   ArrayList getWiderShorterRouteTo( Collection acl_destinationSet, Collection acl_tabooLocations );
   ArrayList getWiderShorterRouteTo( Collection acl_destinationSet, Collection acl_tabooLocations, Collection acl_mustGoLocations );

   ArrayList getWiderShorterRouteFromTo( MotionlessObject acl_origin, MotionlessObject acl_destination );
   ArrayList getWiderShorterRouteFromTo( MotionlessObject acl_origin, MotionlessObject acl_destination, Collection acl_tabooLocations );
   ArrayList getWiderShorterRouteFromTo( MotionlessObject acl_origin, Collection acl_destinationSet, Collection acl_tabooLocations );

   ArrayList getShorterRouteTo( MotionlessObject acl_destination );
   ArrayList getShorterRouteTo( Collection acl_destinationSet );
   ArrayList getShorterRouteTo( MotionlessObject acl_destination, Collection acl_tabooLocations );
   ArrayList getShorterRouteTo( Collection acl_destinationSet, Collection acl_tabooLocations );
   ArrayList getShorterRouteTo( Collection acl_destinationSet, Collection acl_tabooLocations, Collection acl_mustGoLocations );

   ArrayList getShorterRouteFromTo( MotionlessObject acl_origin, MotionlessObject acl_destination );
   ArrayList getShorterRouteFromTo( MotionlessObject acl_origin, MotionlessObject acl_destination, Collection acl_tabooLocations );
   ArrayList getShorterRouteFromTo( MotionlessObject acl_origin, Collection acl_destinationSet, Collection acl_tabooLocations );

   ArrayList getShorterRouteTo_roadThroughHead( Road acl_destinationRoad );
   ArrayList getShorterRouteTo_roadThroughTail( Road acl_destinationRoad );

   ArrayList getShorterRouteTo_thisRoadThroughTheOtherEndPoint();
   ArrayList getShorterRouteTo_thisRoadThroughHead();
   ArrayList getShorterRouteTo_thisRoadThroughTail();
}
