/* PTS */


package rCr.agentModel;


import rCr.agent.I_Agent;
import rCr.util.X_RcR_Accao;
import rCr.agent.skillLevel_1.B_GIS_Router_Yab;
import rCr.agent.skillLevel_1.B_GIS_Router_To;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public class C_RcR_Baseline
extends C_RcR
{
   private I_Agent icl_agent;


   public void setAgent( I_Agent acl_agent )
   {
      this.icl_agent = acl_agent;
   }


   protected void preSimulation()
   {
      icl_agent.setHigherCapability( new B_GIS_Router_To () );
      icl_agent.setHigherCapability( new B_GIS_Router_Yab() );
      icl_agent.preSimulation();
   }


   protected void updateWorld( Object lobj_percepcao )
   {
      icl_agent.updateWorld( lobj_percepcao );
   }


   protected void preAct()
   {
      icl_agent.preAct();
   }


   protected void act()
   throws X_RcR_Accao
   {
      icl_agent.act();
   }


   protected void postAct()
   {
      icl_agent.postAct();
   }


   protected boolean agentHearsItself( int aint_senderID )
   {
      return icl_agent.isSelf( aint_senderID );
   }


   protected boolean acceptHearSay( int aint_senderID, int aint_remainingHearingUtterances )
   {
      return icl_agent.acceptHearSay( aint_senderID, aint_remainingHearingUtterances );
   }


   protected boolean acceptHearTell( int aint_senderID, int aint_remainingHearingUtterances )
   {
      return icl_agent.acceptHearTell( aint_senderID, aint_remainingHearingUtterances );
   }


   protected void handleHearSay( int aint_senderID, String astr_message )
   {
      icl_agent.handleHearSay( aint_senderID, astr_message );
   }


   protected void handleHearTell( int aint_senderID, String astr_message )
   {
      icl_agent.handleHearTell( aint_senderID, astr_message );
   }
}
