/* PTS */

package rCr.agentModel;

import rCr.communicativeAct.C_Sensor;
import rCr.communicativeAct.C_Actuator;
import rCr.agent.I_Agent;
import rCr.agent.skillLevel_0.B_PrimaryCapability;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public interface I_AgentModel
extends Runnable
{
      public void setSensor( C_Sensor acl_sensor );
      public void setAgent( I_Agent acl_agent );
      public void setPrimaryCapability( B_PrimaryCapability acl_primaryCapability );
      /**
       * A RoboCupRescue restriction
       * - specified within the rules of each competition
       */
      public void setHearingLimit( int aint_hearingLimit );
}
