/* PTS */


package rCr.agentWorkingMemory;


/**
 * @author PTS
 * @since JUN.2004
 */
public class E_Point
{
	private int x = 0;
	private int y = 0;


   public E_Point()
   {
   }


   public E_Point( int aint_x, int aint_y )
   {
      this.x = aint_x;
      this.y = aint_y;
   }


   public E_Point( E_Point acl_aPoint )
   {
      this.x = acl_aPoint.getX();
      this.y = acl_aPoint.getY();
   }


	public int getX()
   {
		return x;
	}


	public int getY()
   {
		return y;
	}


   public void setX( int aint_value )
   {
      this.x = aint_value;
   }


   public void setY( int aint_value )
   {
      this.y = aint_value;
   }

   /**
    * Get the closer point (from aarr_pointsToEval) to this one
    */
   public E_Point closerTo( E_Point[] aarr_pointsToEval )
   {
      E_Point lcl_closerPoint = null;
      double ldbl_closerDistance = 0;
      if( aarr_pointsToEval.length > 0 )
      {
         lcl_closerPoint = aarr_pointsToEval[ 0 ];
         ldbl_closerDistance = U_Geometry.getPointToPointDistance( this, lcl_closerPoint );
      }

      for( int iLoop = 1; iLoop < aarr_pointsToEval.length; iLoop++ )
      {
         double ldbl_distance = U_Geometry.getPointToPointDistance( this, aarr_pointsToEval[ iLoop ] );
         if( ldbl_distance < ldbl_closerDistance )
         {
            lcl_closerPoint = aarr_pointsToEval[ iLoop ];
            ldbl_closerDistance = ldbl_distance;
         }
      }
      return lcl_closerPoint;
   }


   public String myToString()
   {
      return " " + "( " + x + ", " +  y + " )";
   }
}
