/* PTS & AR */


/*
 * Created on 17/Mai/2004
 */
package rCr.agentWorkingMemory;
import rCr.util.U_LeitorEscritorLinha;
import yab.agent.object.MotionlessObject;



/**
 * @author aremedios
 * @review PTS
 * @since JUN.2004
 */
public class E_Section
{
	private E_Point topLeft = new E_Point ();
	private E_Point bottomRight = new E_Point ();   
    private int sectionID = -1;

	
	/**
	 * @return
	 */
	public E_Point getBottomRight() {
		return bottomRight;
	}

	/**
	 * @return  UpperLeftCorner Point
	 */
	public E_Point getTopLeft() {
		return topLeft;
	}

	/**
	 * @param point
	 */
	public void setBottomRight(E_Point point) {
		bottomRight = point;
	}

	/**
	 * @param point
	 */
	public void setTopLeft(E_Point point) {
		topLeft = point;
	}
	
	
	public int getBottomRight_X() {
		return bottomRight.getX();
	}
	public int getBottomRight_Y() {
		return bottomRight.getY();
	}
	
	public int getTopLeft_X() {
		return topLeft.getX();
	}
	public int getTopLeft_Y() {
		return topLeft.getY();
	}
	
	public void setBottomRight_X(int x) {
		bottomRight.setX(x) ;
	}
	public void setBottomRight_Y(int y) {
		bottomRight.setY(y) ;
	}
	public void setTopLeft_X(int x) {
		topLeft.setX(x);
	}
	public void setTopLeft_Y(int y) {
		topLeft.setY(y);
	}

	
    public int getSectionID()
    {
       return sectionID;
    }


   public void setSectionID( int aint_sectionID )
   {
      sectionID = aint_sectionID;
   }


   public int getWidth(){
		return bottomRight.getX() - topLeft.getX();
	}


	public int getHeight(){
		return topLeft.getY() - bottomRight.getY();
	}


   /**
   * Checks if point (x, y) is inside this section
    * @param x axis coordenate
    * @param y axis coordenate
    * @return true if (x, y) is inside the section
    */
   public boolean isPointInsideSection( int x, int y )
  {
     boolean lbln_pointInsideSection =
        getTopLeft_X () <= x && getBottomRight_X () >= x &&
        getTopLeft_Y () >= y && getBottomRight_Y () <= y;
	   return lbln_pointInsideSection;
   }

   public void printlnAll()
   {
      U_LeitorEscritorLinha.escrever( "-----" );
      U_LeitorEscritorLinha.escrever( "Section:" );
      U_LeitorEscritorLinha.escrever( "topLeft(x,y) = " + topLeft.myToString() );
      U_LeitorEscritorLinha.escrever( "bottomRight(x,y) = " + bottomRight.myToString() );
      U_LeitorEscritorLinha.escrever( "sectionID = " + sectionID );

   }
}
