/* PTS */


package rCr.agentWorkingMemory;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public interface I_AgentWorkingMemory
{
   // SpaceGrid when no specific grid is set
   public final int pint_numberColumnsSpaceGrid_default = 1;
   public final int pint_numberLinesSpaceGrid_default = 1;

   // PTS: para remover depois da dimensao da grelha
   // ser construida automaticamente
   // Police
   // ------
   // Kobe: col=4 ; lin=3
   // VC: col=2 ; lin=2
   public final int pint_numberColumnsSpaceGrid_POLICE = 3; //4; //3;
   public final int pint_numberLinesSpaceGrid_POLICE = 3; //3;
   // Ambulance
   // ---------
   // Kobe: col=3 ; lin=2
   // VC: col=1 ; lin=2
   public final int pint_numberColumnsSpaceGrid_AMBULANCE = 3; //2;
   public final int pint_numberLinesSpaceGrid_AMBULANCE = 2; //2;
   // Fire
   // ----
   // Kobe: col=3 ; lin=3
   // VC: col=2 ; lin=2
   public final int pint_numberColumnsSpaceGrid_FIRE = 1; //4; //2;
   public final int pint_numberLinesSpaceGrid_FIRE = 1; //3; //2;


   public void initialize( Object acl_object );
   public void postInitialize( Object acl_object );

   /**
    * Add a fact to the working memory object
    */
   // void assert( Object acl_fact );


   /**
    * Add a list of facts to the working memory object
    */
   // void assertAll( List acl_facts );


   /**
    * Remove all facts from the working memory
    */
   // void clear();


   /**
    * Remove a fact from the working memory object
    */
   // void retract( Object acl_fact );


   /**
    * Remove a list of facts from the working memory object
    */
   // void retractAll( List acl_facts );


   /**
    * Tell the working memory object that a fact has changed
    */
   // void modify( Object acl_fact );


   /**
    * Test whether the fact is contained in the working memory object
    */
   // boolean exists( Object acl_fact );


   /**
    * Return a single fact that matches the constraints specified by the Selector
    */
   // Object find( Selector acl_query );


   /**
    * Returns a Collection of facts that match the constraints specified by the Selector
    */
   // AbstractCollection findAll( Selector acl_query );


   /**
    * Find all objects that match the class
    */
   // AbstractCollection findAllInstances( String acl_className );


   /**
    * Retrieve all classes stored in this working memory
    */
   // Enumeration getClasses();


   /**
    * Returns true if the working memory is empty (contains no objects)
    */
   // boolean isEmpty();
}
