/* PTS */


package rCr.communicativeAct;

import rCr.util.X_RcR_Accao;
import yab.io.NozzleElement;



/**
 * @author PTS
 * @since FEV.2002
 */
public class C_Actuator
extends C_CommunicativeActHandler
{
   public void akSay( int aint_idAgente, String astr_conteudo )
   {
      communicator.difundirMensagem( "AkSay", aint_idAgente, astr_conteudo );
   }


   public void akTell( int aint_idAgente, String astr_conteudo )
   {
      communicator.difundirMensagem( "AkTell", aint_idAgente, astr_conteudo );
   }


   public void akRest( int aint_idAgente )
   throws X_RcR_Accao
   {
      communicator.submeterAccao( aint_idAgente, "AkRest" );
      throw new X_RcR_Accao();
   }


   public void akMove( int aint_idAgente, int[] aarr_percurso )
   throws X_RcR_Accao
   {
      communicator.submeterAccao( aint_idAgente, "AkMove", aarr_percurso );
      throw new X_RcR_Accao();
   }


   /**
    * AR, 16-FEV-2004
    * Utility method that rescues someone
    */
   public void akRescue( int aint_idAgent, int aint_idRescuedHumanoid )
   throws X_RcR_Accao
   {
	  communicator.submeterAccao( aint_idAgent, "AkRescue", aint_idRescuedHumanoid );
      throw new X_RcR_Accao();
   }


   /**
    * AR, 16-FEV-2004
    * Carrega um humanoide na ambulancia 
    */
   public void akLoad( int aint_idAgent, int aint_idInjuredHumanoid )
   throws X_RcR_Accao
   {
      communicator.submeterAccao( aint_idAgent, "AkLoad", aint_idInjuredHumanoid );
      throw new X_RcR_Accao();
   }


   /**
    * AR, 18-FEV-2004
    * Desbloqueia um bloqueio de estrada
    */
   public void akClear( int aint_idAgent, int aint_idRoad )
   throws X_RcR_Accao
   {
      communicator.submeterAccao( aint_idAgent, "AkClear", aint_idRoad );
      throw new X_RcR_Accao();
   }


   /**
    * AR, 16-FEV-2004
    * Descarrega um Humanoide da Ambulancia 
    */
   public void akUnLoad( int aint_idAgent )
   throws X_RcR_Accao
   {
	  communicator.submeterAccao( aint_idAgent, "AkUnLoad" );
     throw new X_RcR_Accao();
   }


   /**
    * AR, 19-FEV-2004
    * Descarrega um Humanoide da Ambulancia 
    */
   public void akExtinguish( int aint_idAgent, NozzleElement[] arr_nozzleElement )
   throws X_RcR_Accao
   {
	  communicator.submeterAccao( aint_idAgent, "AkExtinguish", arr_nozzleElement );
     throw new X_RcR_Accao();
   }
}
