/* PTS */

package rCr.communicativeAct;
import rCr.communicator.I_Communicator;
import yab.io.KaConnectOk;


/**
 * @author PTS
 * @since FEV.2002
 */
public class C_CommunicativeActHandler
{
  /**
   * @directed
   */
   protected I_Communicator communicator;


   public I_Communicator getCommunicator()
   {
      return communicator;
   }


   public void setCommunicator( I_Communicator communicator )
   {
      this.communicator = communicator;
   }


   public KaConnectOk akConnect( int aint_tipoAgente )
   {
      Object lobj_respostaKernel = communicator.conectarAgente( aint_tipoAgente );
      
      // Devolver os dados obtidos numa "conexao com sucesso"
      KaConnectOk lobj_kaConnectOk = null;
      if( lobj_respostaKernel instanceof KaConnectOk )
      {
         lobj_kaConnectOk = ( KaConnectOk )lobj_respostaKernel;
      }
      return lobj_kaConnectOk;
   }


   public void akAcknowledge( int aint_idAgente )
   {
      communicator.confirmarConexao( aint_idAgente );
   }
}
