//Source file: D:\\ptrigo\\_PhD\\_RobocupRescue\\_Simulador\\_Agente\\RescueAgent\\Agent\\U_Depurador.java

package rCr.util;


/**
 *  @author PTS
 *  @version 0.0
 *  @since SET-2001
 */
public class U_Depurador implements I_Depurador
{
   
   public U_Depurador() 
   {
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (3/26/00 4:56:35 PM)
 *     @author: PTS
 *     @param aint_nivelDepuracao int
 *     @param astr_mensagem java.lang.String
    */
   public static void escrever(int aint_nivelDepuracao, String astr_nomeClasse, String astr_mensagem) 
   {
      // Nao serao apresentadas mensagens com:
      // - I_Config.kint_depurar igual a I_Config.kint_depurarNada
      // - aint_nivelDepuracao igual a I_Config.kint_depurarNada
      // - aint_nivelDepuracao superior a I_Config.kint_depurar
      if( ( kint_depurar == kint_depurarNada )
          ||
          ( aint_nivelDepuracao == kint_depurarNada )
          ||
          ( aint_nivelDepuracao > kint_depurar ) )
      {
         return;
      }

      // Construir informacao sobre o nivel da mensagem
      String lstr_nivelDepuracao = "";
      switch( aint_nivelDepuracao )
      {
         case kint_depurarErro:
            lstr_nivelDepuracao = "ERRO: ";
            break;
         case kint_depurarAviso:
            lstr_nivelDepuracao = "AVISO: ";
            break;
         case kint_depurarInfo:
            lstr_nivelDepuracao = "INFO: ";
            break;
         case kint_depurarVerboso:
            lstr_nivelDepuracao = "VERBOSO: ";
            break;
      }

      // Escrever mensagem de depuracao
      String lstr_nomeClasse = U_Geral.vazio( astr_nomeClasse ) ?
                               "" : "#" + astr_nomeClasse + "#" + " ";
      String lstr_mensagem = lstr_nivelDepuracao + lstr_nomeClasse + "\"" + astr_mensagem + "\"";
      U_LeitorEscritorLinha.escrever( "" );
      U_LeitorEscritorLinha.escrever( lstr_mensagem );
   }


   public static void escrever(int aint_nivelDepuracao, String astr_mensagem)
   {
      escrever( aint_nivelDepuracao, "", astr_mensagem );
   }


   public static void escrever( Exception acl_excepcao )
   {
      U_LeitorEscritorLinha.escrever( acl_excepcao );
   }
}
