package rCr.util;

import rCr.util.I_Depurador;
import rCr.util.U_Depurador;
import rCr.util.U_Geral;
import java.net.UnknownHostException;
import java.net.DatagramSocket;
import java.net.InetAddress;


public class U_Endereco implements I_Depurador
{
   private InetAddress iadr_enderecoRede = null;
   private int iint_porto;


   public U_Endereco( String astr_nomeNoRede, int aint_porto )
   {
      try
      {
         // Obter e registar endereco da maquina que executa o processo remoto
         //-------------------------------------------------------------------
         iadr_enderecoRede = InetAddress.getByName( astr_nomeNoRede );

      }
      catch( UnknownHostException lexc_excepcao )
      {
         U_Depurador.escrever( lexc_excepcao );
      }

      // Registar o porto em que o processo remoto escuta
      //-------------------------------------------------
      iint_porto = aint_porto;

      // Apresentar info
      //----------------
      apresentarInfo();
   }


   public U_Endereco( InetAddress aadr_enderecoRede, int aint_porto )
   {
      iadr_enderecoRede = aadr_enderecoRede;
      iint_porto = aint_porto;

      // Apresentar info
      //----------------
      apresentarInfo();
   }

   public InetAddress obterEnderecoRede()
   {
      return iadr_enderecoRede;
   }

   public int obterPorto()
   {
      return iint_porto;
   }

   private void apresentarInfo()
   {
      if( null != iadr_enderecoRede )
      {
         U_Depurador.escrever( kint_depurarInfo,
                               U_Geral.paraNomeClasse( this ),
                               "(NO & PORTO) = " + "(" +
                                                   iadr_enderecoRede.toString() +
                                                   " & " +
                                                   iint_porto +
                                                   ")" );
      }
      else
      {
         U_Depurador.escrever( kint_depurarInfo,
                               U_Geral.paraNomeClasse( this ),
                               "---> ENDERECO e PORTO NAO DEFINIDOS !!!" );
      }
   }
}
