/* PTS */

package rCr._BUILDER;


import rCr.initiator.I_Config;
import rCr.agentModel.I_AgentModel;
import rCr.agent.I_Agent;
import rCr.agentWorkingMemory.I_AgentWorkingMemory;
import rCr.agentWorkingMemory.E_WorkingMemory;
import rCr.agentModel.C_RcR_Baseline;
import rCr.agentModel.C_RcR_RRR;
import rCr.agentWorkingMemory.E_WorkingMemory_RRR;
import rCr.agentWorkingMemory.E_WorkingMemory_RRR.E_SpaceGridParameters;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public class C_BUILDER_AmbulanceTeam
extends C_BUILDER_Humanoid

{
   protected int getAgentType()
   {
      return I_Config.AGENT_TYPE_AMBULANCE_TEAM;
   }


   protected I_AgentModel createAgentModel()
   {
      // return new C_RcR_Baseline();
      return new C_RcR_RRR();
   }


   protected I_Agent createAgent()
   {
      // Create Agent
      // return new rCr.agent.rCrAgentBaseline.C_AmbulanceTeam();
      return new rCr.agent.rCrAgentRRR.C_AmbulanceTeam();
   }


   protected I_AgentWorkingMemory createAgentWorkingMemory()
   {
      // return new E_WorkingMemory();
      return new E_WorkingMemory_RRR();
   }


   protected void postWorkingMemoryInitialize( I_AgentWorkingMemory aitf_agentWorkingMemory )
   {
      E_SpaceGridParameters lcl_spaceGridParameters = new E_SpaceGridParameters(
         I_Config.AGENT_TYPE_AMBULANCE_TEAM,
         I_AgentWorkingMemory.pint_numberColumnsSpaceGrid_AMBULANCE, I_AgentWorkingMemory.pint_numberLinesSpaceGrid_AMBULANCE );
      aitf_agentWorkingMemory.postInitialize( lcl_spaceGridParameters );
   }
}
