/* PTS */


package rCr.agent.rCrAgentBaseline;


import rCr.agent.skillLevel_1.problemSolver.B_GIS_RoutingProblem;
import rCr.agent.skillLevel_0.I_PrimaryCapability_Civilian;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import rCr.agent.skillLevel_0.I_PrimaryAction;
import yab.agent.object.Civilian;
import rCr.util.X_RcR_Accao;
import rCr.util.U_Depurador;
import rCr.util.I_Depurador;
import rCr.util.U_Geral;
import yab.agent.object.RealObject;
import java.util.ArrayList;
import java.util.Iterator;
import yab.agent.object.MotionlessObject;
import yab.agent.object.Road;
import rCr.agent.skillLevel_1.problemSolver.E_Node;
import java.util.HashSet;
import java.util.Collections;
import rCr.util.U_LeitorEscritorLinha;
import java.beans.Statement;
import rCr.util.U_RcR;


/**
 *  @author PTS
 *  @since SET.2001
 *  @since MAY.2004
 */
public class C_Civilian_RouterTest
extends C_Humanoid
{
   // Agent Primary Capabilities
   // --------------------------
   private I_PrimaryCapability_Civilian primaryCapability;

   private ArrayList myPath = new ArrayList();
   private int[] yabPath;
   private int iint_pathIndex = 0;
   private final int iint_delay = 1;
   private int iint_delayCounter = 0;


   public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   {
      this.primaryCapability = ( I_PrimaryCapability_Civilian )acl_primaryCapability;
   }


   // PTS: PARA TIRAR
   public I_PrimaryAction getAgentPrimaryCapability()
   {
      return primaryCapability;
   }


   protected Civilian self()
   {
      return ( Civilian )currentDisasterSpace.self;
   }


   public void preSimulation()
   {
      // preSimulationR_Test();
   }

   public void preSimulation_Test()
   {
      long llng_myRouterBegin, llng_myRouterEnd,
           llng_yabRouterBegin, llng_yabRouterEnd;

      System.out.println( "---" );

      System.out.println( "My: ANTES de solve" );
      llng_myRouterBegin = System.currentTimeMillis();
      // My
      // myPath = plannerCapability.getPassableRouteTo( currentDisasterSpace.buildings );
      // myPath = plannerCapability.getWiderShorterRouteTo( currentDisasterSpace.buildings );
      // myPath = plannerCapability.getShorterRouteTo( currentDisasterSpace.buildings );
      // myPath = plannerCapability.getShorterRouteTo( currentDisasterSpace.buildings, currentDisasterSpace.roads );
      // myPath = plannerCapability.getShorterRouteTo_thisRoadThroughTheOtherEndPoint();
      // myPath = plannerCapability.getShorterRouteTo_thisRoadThroughTail();
      // myPath = plannerCapability.getShorterRouteTo_roadThroughTail( ( Road )currentDisasterSpace.roads.get( 3 ) );
      // myPath = plannerCapability.getShorterRouteTo_roadThroughHead( ( Road )currentDisasterSpace.roads.get( 0 ) );
      // myPath = plannerCapability.getShorterRouteTo_roadThroughTail( ( Road )currentDisasterSpace.roads.get( 0 ) );
      // myPath = plannerCapability.getShorterRouteTo_roadThroughTail( ( Road )currentDisasterSpace.roads.get( 3 ) ); //OK
      // myPath = plannerCapability.getShorterRouteTo_roadThroughHead( ( Road )self().motionlessPosition( ) );
      //myPath = plannerCapability.getShorterRouteTo( currentDisasterSpace.buildings,
      //                                              Collections.singleton( ( ( Road )( currentDisasterSpace.roads.get( 3 ) ) ).head() ), // new HashSet(),
      //                                              Collections.singleton( ( ( Road )( currentDisasterSpace.roads.get( 0 ) ) ).head() ) );
      myPath = plannerCapability.getShorterRouteTo( currentDisasterSpace.buildings,
                                                    Collections.singleton( ( ( Road )( currentDisasterSpace.roads.get( 3 ) ) ).head() ),
                                                    Collections.singleton( ( ( Road )( currentDisasterSpace.roads.get( 0 ) ) ).tail() ) );
      //myPath = plannerCapability.getShorterRouteTo( currentDisasterSpace.buildings, currentDisasterSpace.buildings );
      //myPath = plannerCapability.getShorterRouteTo( Collections.singleton( currentDisasterSpace.roads.get( 0 ) ),
      //                                              Collections.singleton( currentDisasterSpace.roads.get( 0 ) ) );
      //myPath = plannerCapability.getShorterRouteTo( self().motionlessPosition() );//,
      //                                              //Collections.singleton( currentDisasterSpace.roads.get( 0 ) ) );

      llng_myRouterEnd = System.currentTimeMillis();
      U_LeitorEscritorLinha.escrever( U_RcR.getIDs( myPath ) );
      System.out.println( "My: DEPOIS de solve" );

      System.out.println( "---" );

      System.out.println( "YabAI: ANTES de solve" );
      llng_yabRouterBegin = System.currentTimeMillis();
      // Yab
      yabPath = plannerCapabilityYab.getPassableRouteIDsTo( currentDisasterSpace.buildings );
      llng_yabRouterEnd = System.currentTimeMillis();
      U_LeitorEscritorLinha.escrever( yabPath );
      System.out.println( "YabAI: DEPOIS de solve" );

      System.out.println( "---" );

      System.out.println( "TEMPO    My: " + ( llng_myRouterEnd - llng_myRouterBegin ) );
      System.out.println( "TEMPO YabAI: " + ( llng_yabRouterEnd - llng_yabRouterBegin ) );
   }


   public void preAct()
   {
   }


   public void act()
   throws X_RcR_Accao
   {
      //act_Test();
   }

   public void act_Test()
   throws X_RcR_Accao
   {
      iint_delayCounter++;
      System.out.println( iint_delayCounter );

      // Path to Test
      ArrayList path = myPath;
      // int[] path = yabPath;

      if( iint_pathIndex >= path.size() )
      {
         return;
      }

      if( iint_delayCounter >= iint_delay )
      {
         ArrayList location = new ArrayList();
         MotionlessObject newPosition = ( MotionlessObject )path.get( iint_pathIndex );
         location.add( newPosition );
         System.out.println( newPosition.id );

         iint_delayCounter = 0;

         // -----------------------------------------------------------------------------------------
         // Create a Statement (object with a target, methodName and arguments as per the parameters)
         // -----------------------------------------------------------------------------------------
         long llng_statementExecutionBegin, llng_statementExecutionEnd;
         llng_statementExecutionBegin = System.currentTimeMillis();
         Object[] larr_argument = { location };
         Statement lcl_statement = new Statement( primaryCapability, "move", larr_argument );
         iint_pathIndex++;
         try
         {
            lcl_statement.execute();
         }
         catch( X_RcR_Accao lcl_exception )
         {
            llng_statementExecutionEnd = System.currentTimeMillis();
            System.out.println( "TEMPO Statement execution: " + ( llng_statementExecutionEnd - llng_statementExecutionBegin ) );
            throw lcl_exception;
         }
         catch( Exception lcl_exception )
         {
            U_LeitorEscritorLinha.escrever( "XXXXXXXXXXXXXXXX" );
            U_LeitorEscritorLinha.escrever( lcl_exception );
         }

         // primaryCapability.move( location );
         // primaryCapability.move( path );
      }
   }


   public void postAct()
   {
      U_Depurador.escrever( I_Depurador.kint_depurarVerboso,
                            U_Geral.paraNomeClasse( this ),
                            "=== posActuar ===" );
   }


   protected void handleCommunicativeAct( RealObject  aobj_emissor, String astr_actoDiscurso )
   {
      System.out.println( "CIVILIAN HEAR: " + astr_actoDiscurso );
      /*
      U_Depurador.escrever( I_Depurador.kint_depurarVerboso,
                            U_Geral.paraNomeClasse( this ),
                            astr_actoDiscurso );
      */
   }
}
