/* PTS */

package rCr.agent.rCrAgentBaseline;
import rCr.initiator.I_Config;
import rCr.util.U_Depurador;
import rCr.util.I_Depurador;
import rCr.util.U_Geral;
import yab.agent.object.AmbulanceCenter;
import yab.agent.object.PoliceOffice;
import yab.agent.object.RealObject;
import yab.agent.object.PoliceForce;
import yab.agent.object.FireBrigade;
import rCr.agent.skillLevel_0.I_PrimaryInteraction;
import rCr.agent.skillLevel_0.B_PrimaryCapability;
import java.lang.reflect.Array;
import yab.agent.object.MotionlessObject;
import yab.agent.object.Humanoid;


/**
 *  @author PTS
 *  @since SET.2001
 *  @author AR
 *  @since FEB.2004
 */
public class C_PoliceOffice
extends C_Center
{
   // Agent Primary Capabilities
   // --------------------------
   
   private I_PrimaryInteraction primaryCapability;


   public void setAgentPrimaryCapability( B_PrimaryCapability acl_primaryCapability )
   {
      this.primaryCapability = ( I_PrimaryInteraction )acl_primaryCapability;
   }


   protected PoliceOffice self()
   {
      return ( PoliceOffice )currentDisasterSpace.self;
   }


   public void preAct()
   {
   }


   public void act()
   {
   }


   public void postAct()
   {
   }


   protected void handleCommunicativeAct( RealObject  aobj_emissor, String astr_actoDiscurso )
   {
      String[] ad_array = astr_actoDiscurso.split(" ");
	   int length = Array.getLength(ad_array);

	   // S aceito msg's vindas dos outros centros
	   if( (aobj_emissor instanceof MotionlessObject) &&
          (length == 6 || length == 5) &&
          ad_array[1].equals("PF") &&
          ( ad_array[2].equals("BLOCKED") || ad_array[2].equals("ROAD_BLOCKADE") ) )
      {
	      println("PoliceOffice, AD: "+ astr_actoDiscurso);	
	      primaryCapability.tell( astr_actoDiscurso );
	   }

	   if( (aobj_emissor instanceof Humanoid) &&
          length == 6 &&
          ad_array[1].equals("PF") &&
          ad_array[1].equals("AT") &&
          ad_array[2].equals("BURIED") )
      {
	      println("PoliceOffice, AD: "+ astr_actoDiscurso);	
	      primaryCapability.tell( astr_actoDiscurso );
	   }

      // recebe info de incendios e envia para bombeiros
      if( (aobj_emissor instanceof Humanoid)
          && length == 6 &&
          ad_array[1].equals("FB") &&
          ad_array[0].equals("PF") &&
          ( ad_array[2].equals("BUILDING_BURNING") || ad_array[2].equals("BURNING") ) )
      {
         println("PoliceOffice, AD: "+ astr_actoDiscurso);
         primaryCapability.tell( astr_actoDiscurso );
      }
   }


   private void println( String str)
   {
      System.out.println(str);
	}
}
