/* PTS */


package rCr.agent.rCrAgentRRR.r0;


import rCr.agent.skillLevel_0.I_PrimaryCapability_AmbulanceTeam;
import rCr.agent.skillLevel_1.I_Planner;
import rCr.agent.rCrAgentRRR.C_Agent;


/**
 * @author PTS
 * @since JUN.2004
 * @see .xls file
 */
public class E_RuleSet_AT
extends E_RuleSet
{
   /**
    * Build AmbulanceTeam RuleSet
    * @see .xls file (rule and salience specification)
    */
   public E_RuleSet_AT( C_Agent agent, I_PrimaryCapability_AmbulanceTeam primaryCapability, I_Planner plannerCapability )
   {
      // --------------------------
      // 1st: the Interaction Rules
      // --------------------------
      U_RuleSpecification_Interaction rsI = new U_RuleSpecification_Interaction();

      E_Rule rsI_01 =
         rsI.getRule_IF_self_ALIVE_x_BURIED_THEN_tell(
            agent, primaryCapability );

      // -------------------------
      // Add the Interaction Rules
      // -------------------------
      addInteractionRule( rsI_01, 1 );

      // ---------------------
      // 2nd: the Action Rules
      // ---------------------
      U_RuleSpecification_Action rsA = new U_RuleSpecification_Action();

      E_Rule rsA_01 =
         rsA.getRule_loaded_IF_self_motionlessPosition_NOT_REFUGE_THEN_moveREFUGE(
            agent, primaryCapability, plannerCapability );

      E_Rule rsA_02 =
         rsA.getRule_loaded_IF_self_motionlessPosition_REFUGE_THEN_unload(
            agent, primaryCapability );

     E_Rule rsA_03 =
         rsA.getRule_damage_IF_self_motionlessPosition_REFUGE_THEN_rest(
            agent, primaryCapability );

     E_Rule rsA_04 =
         rsA.getRule_not_loaded_not_refuge_IF_other_here_ALIVE_DAMAGE_NOT_BURIED_THEN_load(
            agent, primaryCapability );

     E_Rule rsA_05 =
         rsA.getRule_not_refuge_IF_self_ALIVE_DAMAGE_NOT_BURIED_THEN_moveREFUGE(
            agent, primaryCapability, plannerCapability );

     E_Rule rsA_06 =
         rsA.getRule_not_loaded_IF_other_here_ALIVE_x_BURIED_THEN_rescue(
            agent, primaryCapability );

      // --------------------
      // Add the Action Rules
      // --------------------
      addActionRule( rsA_01, 1 );
      addActionRule( rsA_02, 2 );
      addActionRule( rsA_03, 3 );
      addActionRule( rsA_04, 4 );
      // Both rsA_05 and rsA_06 have the same salience == 5
      // see .xls file
      addActionRule( rsA_05, 5 );
      addActionRule( rsA_06, 6 );
   }
}
