/* PTS */


package rCr.agent.rCrAgentRRR.r0;


import java.util.List;
import yab.agent.Condition;
import yab.agent.object.Humanoid;
import rCr.agentWorkingMemory.E_FactMemory;
import yab.agent.DisasterSpace;
import rCr.util.U_Geral;
import java.beans.Statement;
import java.util.ArrayList;
import rCr.agentWorkingMemory.I_FactMemoryConstants;
import java.util.ListIterator;
import rCr.agentWorkingMemory.E_FactMemory.E_Fact;
import rCr.agent.rCrAgentRRR.I_Feature;
import rCr.util.E_Condition;
import java.util.Iterator;
import rCr.agent.skillLevel_0.I_PrimaryInteraction;
import rCr.agent.rCrAgentRRR.C_AmbulanceTeam;
import rCr.agent.skillLevel_0.I_PrimaryInteraction_Constants;


/**
 *  @author PTS
 *  @since JUN.2004
 */
public class U_RuleSpecification_Util
implements I_Feature, I_PrimaryInteraction_Constants
{
   static synchronized List buildList_other_here_HEALTH_SITUATION(
         List aitf_humanoids, Condition acl_HEALTH_SITUATION, final Humanoid acl_self )
   {
         // Build the list of Humanoids here (at the self motionlessPosition)
         // List lift_here = PRP_POSITION.eq( acl_self.motionlessPosition() ).extract( aitf_humanoids );
         List lift_here = PRP_POSITION.eq( acl_self.position() ).extract( aitf_humanoids );
         // Build the list of Humanoids here (at the self motionlessPosition),
         // with intended HEALTH_SITUATION
         List lift_here_HEALTH_SITUATION = acl_HEALTH_SITUATION.extract( lift_here );

         E_Condition lC_other =
         new E_Condition()
         {
            public boolean eval( Object acl_selfHumanoid )
            {
               Humanoid lcl_humanoid = ( Humanoid )acl_selfHumanoid;
               return ( lcl_humanoid != acl_self );
            }
         };
         // Build the list of Humanoids here (at the self motionlessPosition),
         // with intended HEALTH_SITUATION,
         // except for self (that is, the "other" Humanoids)
         return lC_other.extract( lift_here_HEALTH_SITUATION );
   }


   static synchronized List buildList_other_ALIVE_x_BURIED(
      List aitf_humanoids, final Humanoid acl_self )
   {
         // Build the list of Humanoids,
         // that I know to be ALIVE_x_BURIED
         List lift_ALIVE_x_BURIED = I_Feature.CND_ALIVE_x_BURIED.extract( aitf_humanoids );

         E_Condition lC_other =
         new E_Condition()
         {
            public boolean eval( Object acl_selfHumanoid )
            {
               Humanoid lcl_humanoid = ( Humanoid )acl_selfHumanoid;
               return ( lcl_humanoid != acl_self );
            }
         };
         // Build the list of Humanoids,
         // that I know to be ALIVE_x_BURIED,
         // except for self (that is, the "other" Humanoids)
         return lC_other.extract( lift_ALIVE_x_BURIED );
   }


   /**
    * HEALTH@ADB AgPOS AgID#DB AgPOS AgID#...
    * @see .xls file
    */
   static synchronized String buildMessageContent_SELF_AT_HDB_POS_ID( E_FactMemory acl_factMemory )
   {
      DisasterSpace lcl_disasterSpace = acl_factMemory.getCurrentDisasterSpace();
      Humanoid lcl_self = ( Humanoid )( lcl_disasterSpace.self );

      // Build message content
      // ---------------------
      String lstr_messageContent =
         pstr_SITUATION_HEALTH +
         pstr_SITUATION_SEPARATOR +
         buildMessage_HDB_POS_ID( lcl_self ) +
         pstr_BLOCK_SEPARATOR;
      return lstr_messageContent;
   }


   /**
    * HEALTH@ADB AgPOS AgID#DB AgPOS AgID#...
    * maximum number of bytes == 256 (RcR2004)
    * @see .xls file
    */
   static synchronized String buildMessageContent_OTHER_AT_HDB_POS_ID( E_FactMemory acl_factMemory )
   {
      List llst_HDB_POS_ID = ( List )( acl_factMemory.
         getLastFact( I_FactMemoryConstants.kint_candidateStatementRuleArguments ).fact );

      // HEALTH@ADB AgPOS AgID#DB AgPOS AgID#...
      String lstr_messageContent =
         pstr_SITUATION_HEALTH +
         pstr_SITUATION_SEPARATOR;

      boolean lbln_stop = false;
      for( Iterator litf_iterator = llst_HDB_POS_ID.iterator();
           litf_iterator.hasNext() && ( ! lbln_stop ); )
      {
         Humanoid lcl_humanoid = ( Humanoid )litf_iterator.next();
         String lstr_message = buildMessage_HDB_POS_ID( lcl_humanoid );

         int lint_totalBytes =
            lstr_messageContent.length() +
            lstr_message.length() +
            pstr_BLOCK_SEPARATOR.length();

         if( lint_totalBytes <= pint_maximum_MESSAGE_BYTES)
         {
            lstr_messageContent =
               lstr_messageContent +
               lstr_message +
               pstr_BLOCK_SEPARATOR;
         }
         else
         {
            lbln_stop = true;
         }
      }
   return lstr_messageContent;
   }


   public static synchronized String buildMessage_HDB_POS_ID( Humanoid lcl_humanoid )
   {
      String H    = U_Geral.paraString( lcl_humanoid.hp() );
      String D    = U_Geral.paraString( lcl_humanoid.damage() );
      String B    = U_Geral.paraString( lcl_humanoid.buriedness() );
      String POS  = U_Geral.paraString( lcl_humanoid.motionlessPosition().id );
      String ID   = U_Geral.paraString( lcl_humanoid.id );

      // Build message
      // -------------
      String lstr_message =
         H   + pstr_TOKEN_SEPARATOR +
         D   + pstr_TOKEN_SEPARATOR +
         B   + pstr_TOKEN_SEPARATOR +
         POS + pstr_TOKEN_SEPARATOR +
         ID;
      return lstr_message;
   }


   static synchronized Statement findLastStatementMethodName( E_FactMemory acl_factMemory, String astr_methodName )
   {
      ArrayList larr_factSet = acl_factMemory.getFactSet( I_FactMemoryConstants.kint_executedStatementRule );
      Statement lstt_statement = null;
      boolean lbln_found = false;
      // Iterate backwards
      for( ListIterator litf_listIterator = larr_factSet.listIterator( larr_factSet.size() );
           litf_listIterator.hasPrevious() && ( ! lbln_found ); )
      {
         E_Fact lcl_fact = ( E_Fact )( litf_listIterator.previous() );
         lstt_statement = ( Statement )lcl_fact.fact;
         lbln_found = lstt_statement.getMethodName().equals( astr_methodName );
      }
      return lbln_found ? lstt_statement : null;
   }


   static synchronized void assertTrueFact_candidateStatementRuleArguments(
      boolean abln_truthValue, List alst_candidateArgumentList, E_FactMemory acl_factMemory )
   {
      if( ! abln_truthValue )
      {
         return;
      }
      E_Fact lcl_fact = new E_Fact( I_FactMemoryConstants.kint_candidateStatementRuleArguments, alst_candidateArgumentList );
      acl_factMemory.assertFact( lcl_fact );
   }


   static synchronized List getPossibleToRescue( List acl_toRescue )
   {
      ArrayList larr_result = new ArrayList();
      if( acl_toRescue.isEmpty() )
      {
         return larr_result;
      }
      for( Iterator litf_iterator = acl_toRescue.iterator();
          litf_iterator.hasNext(); )
      {
         Humanoid lcl_humanoidToRescue = ( Humanoid )litf_iterator.next();
         Integer lInt_timeToDie = C_AmbulanceTeam.timeToDie( lcl_humanoidToRescue.hp(),
                                                             lcl_humanoidToRescue.damage(),
                                                             lcl_humanoidToRescue.buriedness() );
         if( ( lInt_timeToDie != null ) && ( lInt_timeToDie.intValue() > 0 ) )
         {
            larr_result.add( lcl_humanoidToRescue );
         }
      }
      return larr_result;
   }


   private static void println( String str)
   {
	   //System.out.println(self().id+":"+str);
	   System.out.println( str );
	}
}
