/* PTS */


package rCr.agent.skillLevel_1.problemSolver;


import java.util.ArrayList;
import java.util.LinkedList;


/**
 *  @author PTS
 *  @since MAY.2004
 */
class C_BreadthFirst
implements I_SearchStrategy
{
   /**
    * C_BreadthFirst: insert new nodes at the end of the queue
    */
   public void addNodesToQueue( ArrayList aarr_nodeList, LinkedList acl_nodeQueue )
   {
      for( int lint_iLoop = 0; lint_iLoop < aarr_nodeList.size(); lint_iLoop++ )
      {
         acl_nodeQueue.addLast( aarr_nodeList.get( lint_iLoop ) );
      }
   }


   /**
    * Exemplo utilizacao da "conditionPreExpand":
    * nao expandir um elemento para
    * alem de determinada profundidade
    * ===
    * true: allows the state (acl_currentNode.getState()) expand
    * false: does not allow the state expand
    */
   public boolean preStateExpandCondition( E_Node acl_currentNode )
   {
      return true;
   }


   /**
    * Exemplo utilizacao da "postStateExpandCondition":
    * nao considerar um elemento cujo
    * estado ja tenha sido considerado
    * (tres situacoes: como pai; no mesmo ramo; em toda a arvore)
    * ===
    * true: allows the state (acl_currentNode.getState())
    *       to enter the "fringe queue" of states
    * false: does not allow the state to enter the "fringe queue" of states
    */
   public boolean postStateExpandCondition( E_Node acl_parentNode, I_State aitf_aNextState )
   {
      return true;
   }
}
