/* PTS */


package rCr.agent.skillLevel_1.problemSolver;


import yab.agent.object.MotionlessObject;
import yab.agent.object.PointObject;
import yab.agent.object.Road;


/**
 *  @author PTS
 *  @since MAY.2004
 */
public class E_GIS_move_shorterRoad
extends E_GIS_move
{
   /**
    * Cost is the distance (between origin and destinaton)
    * cost = lenghtOfRoad
    */
   public float getCost( I_State acl_currentState, I_State acl_nextState )
   {
      B_GIS_RoutingProblem.E_State lcl_stateOrigin = ( B_GIS_RoutingProblem.E_State )acl_currentState;
      B_GIS_RoutingProblem.E_State lcl_stateDestination = ( B_GIS_RoutingProblem.E_State )acl_nextState;
      MotionlessObject lcl_origin = lcl_stateOrigin.gisLocation;
      MotionlessObject lcl_destination = lcl_stateDestination.gisLocation;

      // Only moving "into a Road" has a cost
      // ------------------------------------
      float lflt_cost = 0;

      boolean lbln_moveIntoRoad = ( lcl_destination instanceof Road );
      if( lbln_moveIntoRoad )
      {
         Road lcl_road = ( Road )lcl_destination;
         lflt_cost = lcl_road.length();
      }
      return lflt_cost;
   }
}
