/* PTS */


package rCr.agent.skillLevel_1.problemSolver;


import java.util.ArrayList;
import java.util.LinkedList;


public interface I_SearchStrategy
{
   public void addNodesToQueue( ArrayList aarr_nodeList, LinkedList acl_nodeQueue );
   /**
    * Exemplo utilizacao da "conditionPreExpand":
    * nao expandir um elemento para
    * alem de determinada profundidade
    * ===
    * true: allows the state (acl_currentNode.getState()) expand
    * false: does not allow the state expand
    */
   public boolean preStateExpandCondition( E_Node acl_currentNode );
   /**
    * Exemplo utilizacao da "postStateExpandCondition":
    * nao considerar um elemento cujo
    * estado ja tenha sido considerado
    * (tres situacoes: como pai; no mesmo ramo; em toda a arvore)
    * ===
    * true: allows the state (acl_currentNode.getState())
    *       to enter the "fringe queue" of states
    * false: does not allow the state to enter the "fringe queue" of states
    */
   public boolean postStateExpandCondition( E_Node acl_parentNode, I_State aitf_aNextState );
}
