/* PTS */

package rCr.communicator;

import java.io.ByteArrayOutputStream;
import rCr.util.U_ListaDigitoBinario;
import rCr.util.U_Endereco;
import yab.io.NozzleElement;


/**
 *  @author PTS
 *  @since FEV.2002
 */
public interface I_Communicator 
{
   public void registarEnderecoProcessoRemoto( U_Endereco acl_enderecoNoRemoto );
   public Object conectarAgente( int aint_tipoAgente );
   public void confirmarConexao( int aint_idAgente );
   public Object obterPercepcao();

   /**
    * SAY & TELL (all);
    */
   public void difundirMensagem( String astr_mensagem, int aint_idAgente, String astr_conteudo );

   /**
    * AR, 16-FEV-2004
    * AK_UNLOAD (AmbulanceTeam);
    * AK_REST (all)
    */
   public void submeterAccao( int aint_idAgente, String astr_accao );

   /**
    * AR, 16-FEV-2004
    * AK_EXTINGUISH (FireBrigade);
    * AK_REST (all)
    */
   public void submeterAccao( int aint_idAgente, String astr_accao, int[] arr_argumento );

   /**
    * AR, 16-FEV-2004
    * AK_RESCUE, AK_LOAD (AmbulanceTeam);
    * AK_CLEAR (PoliceForce)
    */
   public void submeterAccao( int aint_idAgente, String astr_accao, int aint_argumento );
   public void submeterAccao( int aint_idAgente, String astr_accao, NozzleElement[] arr_argumento );
}