/* PTS */

package rCr.initiator;

import rCr.util.U_Depurador;
import rCr.util.I_Depurador;
import rCr.util.U_Geral;
import rCr.util.U_Endereco;


public class E_InitiatorCommunicator
implements I_InitiatorCommunicator, I_Depurador
{
   /**
    * @directed
    */
   private E_Initiator ie_initiator;


   public E_InitiatorCommunicator( E_Initiator ae_initiator )
   {
      ie_initiator = ae_initiator;
   }

   public Object obterObjectoComunicador()
   {
      String lstr_classeComunicadora = ie_initiator.obterNomeClasseComunicadora();

      U_Depurador.escrever( kint_depurarVerboso,
                            U_Geral.paraNomeClasse( this ),
                            "ClasseComunicadora:" + lstr_classeComunicadora );

      return U_Geral.paraObject( lstr_classeComunicadora );
   }

   /**
   * Obter endereco do processo remoto
   * - o processo "servidor"
   */
   public U_Endereco obterEnderecoProcessoRemoto()
   {
      return new U_Endereco( ie_initiator.obterNomeNoRemoto(),
                             ie_initiator.obterPortoProcessoRemoto() );
   }
}
