/* PTS */

package rCr.util;


/**
 *  Criado: (2/17/00 10:46:18 PM)
 *  @author: Paulo Trigo Silva
 */
public class X_PreCondicao
extends Exception
implements I_Depurador
{
   
   /**
 *     Mensagem explicativa da excepcao
    */
   private String istr_mensagem = "";
   
   /**
 *     Nome da classe que detectou a excepcao
    */
   private String istr_classeQueDetectouExcepcao = "";
   

   public X_PreCondicao(Object aobj_objectoQueDetectouExcepcao, String astr_mensagem) 
   {
      // Construtor da classe pai
      super();
	
      // Guardar a mensagem para posterior apresentacao
      istr_mensagem = astr_mensagem;

      // Guardar o nome da classe de cuja instancia ocorreu a excepcao de Pre-Condicao
      istr_classeQueDetectouExcepcao = U_Geral.paraNomeClasse( aobj_objectoQueDetectouExcepcao );
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (4/9/00 3:28:42 PM)
 *     @author: PTS
    */
   public void escrever() 
   {
      // Escrever mensagem, caso o nivel de depuracao inclua o de Erro
      U_Depurador.escrever(
         kint_depurarErro,
         "Excepcao na Classe: " + "\"" + istr_classeQueDetectouExcepcao + "\"",
         "S_PreCondicao: " + "\"" + istr_mensagem + "\"" );
   }
   
   /**
 *     Insert the method's description here.
 *     Criado: (4/9/00 3:28:42 PM)
 *     @author: PTS
    */
   public String obterMensagem() 
   {
     return istr_mensagem;
   }
}
